// Code generated by Wire. DO NOT EDIT.

//go:generate wire
//+build !wireinject

package main

import (
	"github.com/sirupsen/logrus"
	"gitlab.com/smotrova-otus/libs/uuid-go"
	application2 "gitlab.com/smotrova-otus/ls-social-network/chat/chat/application"
	"gitlab.com/smotrova-otus/ls-social-network/chat/chat/infrastructure/datasources"
	"gitlab.com/smotrova-otus/ls-social-network/chat/chat/infrastructure/datasources/mysql"
	endpoints2 "gitlab.com/smotrova-otus/ls-social-network/chat/chat/infrastructure/endpoints"
	http2 "gitlab.com/smotrova-otus/ls-social-network/chat/chat/infrastructure/transport/http"
	"gitlab.com/smotrova-otus/ls-social-network/chat/config"
	"gitlab.com/smotrova-otus/ls-social-network/chat/pkg/clock"
	"gitlab.com/smotrova-otus/ls-social-network/chat/pkg/database"
)

import (
	_ "github.com/go-sql-driver/mysql"
)

// Injectors from wire.go:

func NewContainer(cfg2 *config.Config, logger2 *logrus.Entry, masterConn2 *database.MasterConnection, slavesConn2 *database.SlaveConnection, chatShardedPool2 mysql.ShardedPool) (*Container, func(), error) {
	jwtStrategyConfig := provideJwtStrategyConfig(cfg2)
	realClock := clock.NewRealClock()
	serviceJwt := token.NewJwtService(jwtStrategyConfig, realClock)
	accountRepositoryImpl := auth.NewAccountRepository(masterConn2)
	passwordHasherImpl := passwordhash.NewPasswordHasherImpl()
	generatorImpl := uuid.NewGeneratorImpl()
	service := auth.NewService(serviceJwt, accountRepositoryImpl, passwordHasherImpl, generatorImpl)
	endpointParams := auth2.EndpointParams{
		JWTStrategyConfig: jwtStrategyConfig,
	}
	authEndpoints := auth.MakeServerEndpoints(service, endpointParams)
	httpHandlerParams := auth.HTTPHandlerParams{
		Logger: logger2,
	}
	httpHandlerSet := auth.NewHTTPHandlerSet(authEndpoints, httpHandlerParams)
	repositoryImpl := profile.NewProfileRepository(masterConn2, slavesConn2)
	connection, cleanup, err := newAMQPConn(cfg2, logger2)
	if err != nil {
		return nil, nil, err
	}
	channel, cleanup2, err := newAMQPChannel(connection, logger2)
	if err != nil {
		cleanup()
		return nil, nil, err
	}
	backOff := newAMQPPublisherBackoff(cfg2)
	publisherImpl, err := profile.NewPublisher(channel, logger2, backOff)
	if err != nil {
		cleanup2()
		cleanup()
		return nil, nil, err
	}
	profileService := profile.NewService(repositoryImpl, generatorImpl, publisherImpl)
	profileEndpoints := profile.MakeServerEndpoints(profileService, endpointParams)
	profileHTTPHandlerParams := profile.HTTPHandlerParams{
		Logger: logger2,
	}
	profileHTTPHandlerSet := profile.NewHTTPHandlerSet(profileEndpoints, profileHTTPHandlerParams)
	client := provideRedisClient(cfg2)
	inMemoryPostsLimit := provideRedisInmemoryPostsLimit(cfg2)
	postRepository := redis.NewPostRepository(client, inMemoryPostsLimit)
	mysqlPostRepository := mysql2.NewPostRepository(masterConn2, slavesConn2)
	postPublisher, err := amqp.NewPostPublisher(channel, logger2, backOff)
	if err != nil {
		cleanup2()
		cleanup()
		return nil, nil, err
	}
	cacheInMemoryPostsLimit := provideCacheInmemoryPostsLimit(cfg2)
	cachePostRepository := cache.NewCacheablePostRepository(postRepository, mysqlPostRepository, postPublisher, cacheInMemoryPostsLimit)
	applicationService := application.NewService(cachePostRepository, postRepository, repositoryImpl, postPublisher)
	set := endpoints.New(applicationService)
	httpSet := http.New(set, logger2)
	messageRepository := mysql.NewMessageRepository(chatShardedPool2)
	chatRepository := mysql.NewChatRepository(masterConn2, slavesConn2)
	memberRepository := datasources.NewMemberRepository(repositoryImpl)
	service2 := application2.NewService(messageRepository, chatRepository, memberRepository)
	endpointsSet := endpoints2.New(service2)
	set2 := http2.New(endpointsSet, logger2)
	amqpSet := amqp2.New(set, logger2)
	container := &Container{
		AuthHTTPHandlerSet:     httpHandlerSet,
		ProfileHTTPHandlerSet:  profileHTTPHandlerSet,
		PostsHTTPHandlerSet:    httpSet,
		ChatHTTPHandlerSet:     set2,
		PostsAMQPSubscriberSet: amqpSet,
		AMQPChannel:            channel,
	}
	return container, func() {
		cleanup2()
		cleanup()
	}, nil
}

// wire.go:

func provideJwtStrategyConfig(cfg2 *config.Config) token.JWTStrategyConfig {
	return token.JWTStrategyConfig{
		Key:      []byte(cfg2.Auth.Key),
		Ttl:      cfg2.Auth.Ttl,
		Audience: cfg2.Auth.Audience,
		Issuer:   cfg2.Auth.Issuer,
	}
}
